# Assignment Scenarios

The following scenarios provide a background for the assessed portfolio work for this module. From the scenarios below, you are expected to identify one of the problems they have and explore a solution to this. You will be guided weekly on what you need to do and you do not need to provide a completed working code project for the problem. The focus is more on the process of applying computational thinking and writing short pieces of code that demonstrate your approach and understanding.

# E-Sports League

**Face Off** is a new, recently funded, totally original organisation who host e-sports tournaments for a number of competitive games. Faceoff have a number of different challenges related to their products, ranging from matchmaking systems to AI recommendation engines for in game performance and cheat detection. Faceoff are also pioneering a new e-sport format in which players compete for overall titles by playing a selection of different games, aiming to find the next 'masters of gaming', not just the master of one game.
For their match making system, players skill levels should be tracked across games and matches should be made for players of comparable skill levels. Their AI engine tracks the movement and play style of the player and makes recommendations for them to improve. Face Off are also exploring the use of creating 'player signatures' to identify when a player is cheating, by monitoring player behaviour and using AI to detect patterns that suggest the use of cheat software. Face Off invites you to focus on one of these problems and present a potential solution.

***Highlighted problem:*** The match making system will be at the core of Face Off's business model, where players are scored based on their ability in a given game and then matched against other players of similar ability. In this process, match making should consider a range of other factors such as best locations for servers to reduce latency (commonly called ping), putting players in teams that are more likely to speak the same language and also player reputation (such that players who are regularly reported for bad in game practices are less likely to be matched with those who aren't). Match making is a process that can also draw on the existing approaches used by competitors. 
# Pet Tracker

**SnoopPets** have entered the market with a new, feature rich pet tracker with models to suit pets of various types. The company is wheel funded by a single anonymous backer and is looking for solutions for some of its latest feature offerings. SnoopPets' new tracker, the Snoopy9000 features GPS tracking, an inertial measurement unit (IMU), temperature sensor, humidity sensor,  a speaker and a microphone. The goal for this product is to first identify and then track animal behaviours, such that owners can better understand the needs of their pets. Notifications for animal behaviours and recommendations for treatment, products and quality of life can then be recommended for pets. Other peripheral features such as 'find-my-pet' are also planned. Due to the nature of this tracker and the information it collects social, legal, ethical and professional issues should be considered when proposing ways in which this might be achieved. 

***Highlighted problem:*** The 'find-my-pet' feature allows the use of the Snoop pets sensor to be used to show the location of a pet to assist in retrieval. All sensors are available for this feature and may be utilised in helping to locate the pet as well as to indicate to anyone that finds the pet, where and how to contact the owner. The Snoopy9000 does not feature enough processing power to produce text to speech but prerecorded audio files can be played and could include fragmented text and the ability to play these in specific orders.
# Music Recommendation

**Tunify** are changing the way you are recommended music through deep integration with you engagement with entertainment. Much like competitors, **Tunify** will make recommendations based on your existing music by introducing related bands (using information such as genre and music that other listeners also enjoy). **Tunify** plan to extend this by also factoring in musical similarities by analysing songs using metrics such as instrumentation, harmony and 'musical-complexity' and make recommendations for new music that is similar. We invite solutions to develop this recommendation engine with the opportunity to focus on any element in detail or to consider a higher level integration of the whole system.

***Highlighted problem:*** Because Tunify are looking to make recommendations on musical characteristics, they are keen to build out a system for identifying musical characteristics of a song and relating this to other songs. This system should be able to relate different combinations of musical characteristics and suggest songs that are also closely related. They are particularly keen for this to allow for 'discovery', so ideally these do not have to be perfect 100% matches but instead relate by a configurable tolerance of related characteristics.
# E Vehicle Battery Management

**Greenstores** is designing new systems to manage power consumption as we transition to increased use of battery storage. It is a key challenge to ensure that the grid can support the fluctuations in demand for the nations power using sustainable methods. In support of greener energy, it is important to consider how peaks in power demand can be managed without the need to fall back on fossil fuel powered plants. Greenstores believes that as many electric vehicles (EVs) are not in continuous use throughout the day, the batteries of these vehicles could be used to help with the grids power management by being charged when energy is abundant, and feeding power back into the grid when there is demand. This would help to meet demand at peak times without fossil fuels (by charging using renewables when they are available). These EVs can then be recharged off peak to also save users money. This system needs to be considerate of the work patterns of their different users and ensure that some power remains for emergency use. 

***Highlighted problem:*** Greenstores most important demonstration for its investors is fast approaching and they need to demonstrate their adaptive charging strategy which suggests the best time for charging based on user schedules. Users are expected to first describe this schedule but it should be tracked automatically such that if their day to day routine changes significantly, the charge times are adapted. The main goal for this system is to contribute as much power at peak times (between 7:00-9:00 and 18:00-21:00) and for cars to be charged off peak (between 23:00-6:00). While seasonal changes are not important for the demo, they will be in the future and could also be considered.
